
#define  QNANBITPATT_SP32  0x7fc00000
#define  as_int(x) __builtin_astype(x, int)
#define  as_float(x) __builtin_astype(x, float)

inline float fdim(float x, float y)
{
   int n = -(__builtin_isnan(x) | __builtin_isnan(y)) & QNANBITPATT_SP32;
   int r = -(x>y) | as_int(x-y);
   return as_float(n | r);
}

__kernel void test(global float *r, float x, float y)
{
   *r = fdim(x, y);
}
