#define  QNANBITPATT_SP32  0x7fc00000
#define  as_int(x) __builtin_astype(x, int)
#define  as_float(x) __builtin_astype(x, float)

inline float fdim(float x, float y)
{
   if (__builtin_isnan(x) || __builtin_isnan(y))
      return as_float(QNANBITPATT_SP32);
   return __builtin_fmax(x-y, 0);
}

__kernel void test(__global float *r, float x, float y)
{
   *r = fdim(x, y);
}
